
Ruby - Bug #11571

シングルトンメソッドの中で def を使用した時の可視性が変わっている

10/07/2015 06:11 AM - hsbt (Hiroshi SHIBATA)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version:    

ruby -v: ruby 2.3.0dev (2015-10-05 trunk 52041) Backport: 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2:

UNKNOWN

Description

以下のコードの可視性が 2.3 と 2.2 で異なっているようです

https://github.com/radar/paranoia/blob/rails4/lib/paranoia.rb#L189

ruby 2.3.0dev (2015-10-05 trunk 52041) では private,

ruby 2.2.4p179 (2015-10-05 revision 52032) では public になります。

意図しない非互換な変更と思いますので修正をお願いします。

Related issues:

Related to Ruby - Bug #13249: Access modifiers don't have an effect inside cl... Closed

Associated revisions

Revision 25f5dd6799bbacc9f61d60b87b70ea6e6d815c20 - 11/13/2015 05:38 PM - ko1 (Koichi Sasada)

vm.c (vm_define_method): do not use current CREF immediately,

but check CREF in environment or methods. Methods defined in methods

should be public.

[Bug #11571]

vm_method.c (rb_scope_module_func_check): check CREF in env or me.

if CREF is contained by `me', then return FALSE.

test/ruby/test_method.rb: add a test.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@52562 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 25f5dd67 - 11/13/2015 05:38 PM - ko1 (Koichi Sasada)

vm.c (vm_define_method): do not use current CREF immediately,

but check CREF in environment or methods. Methods defined in methods

should be public.

[Bug #11571]

vm_method.c (rb_scope_module_func_check): check CREF in env or me.

if CREF is contained by `me', then return FALSE.

test/ruby/test_method.rb: add a test.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@52562 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/13/2015 05:38 PM - ko1 (Koichi Sasada)

- Status changed from Open to Closed

Applied in changeset r52562.
https://github.com/radar/paranoia/blob/rails4/lib/paranoia.rb#L189


vm.c (vm_define_method): do not use current CREF immediately,

but check CREF in environment or methods. Methods defined in methods

should be public.

[Bug #11571]

vm_method.c (rb_scope_module_func_check): check CREF in env or me.

if CREF is contained by `me', then return FALSE.

test/ruby/test_method.rb: add a test.

#2 - 02/24/2017 10:53 PM - nobu (Nobuyoshi Nakada)

- Related to Bug #13249: Access modifiers don't have an effect inside class methods in Ruby >= 2.3 added
